Index: abi/include/abi/bool.h
===================================================================
--- abi/include/abi/bool.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ abi/include/abi/bool.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -36,5 +36,5 @@
 #define ABI_BOOL_H_
 
-#define bool _Bool
+typedef uint8_t bool;
 
 #endif
Index: abi/include/abi/mm/as.h
===================================================================
--- abi/include/abi/mm/as.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ abi/include/abi/mm/as.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -37,10 +37,8 @@
 
 /** Address space area flags. */
-#define AS_AREA_READ         0x01
-#define AS_AREA_WRITE        0x02
-#define AS_AREA_EXEC         0x04
-#define AS_AREA_CACHEABLE    0x08
-#define AS_AREA_GUARD        0x10
-#define AS_AREA_LATE_RESERVE 0x20
+#define AS_AREA_READ       1
+#define AS_AREA_WRITE      2
+#define AS_AREA_EXEC       4
+#define AS_AREA_CACHEABLE  8
 
 /** Address space area info exported to uspace. */
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/Makefile.common	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -109,4 +109,5 @@
 	$(USPACE_PATH)/srv/fs/exfat/exfat \
 	$(USPACE_PATH)/srv/fs/udf/udf \
+	$(USPACE_PATH)/srv/fs/ext2fs/ext2fs \
 	$(USPACE_PATH)/srv/fs/ext4fs/ext4fs \
 	$(USPACE_PATH)/srv/hid/remcons/remcons \
@@ -166,4 +167,5 @@
 	$(USPACE_PATH)/app/dload/dload \
 	$(USPACE_PATH)/app/edit/edit \
+	$(USPACE_PATH)/app/ext2info/ext2info \
 	$(USPACE_PATH)/app/inet/inet \
 	$(USPACE_PATH)/app/kill/kill \
Index: boot/Makefile.uboot
===================================================================
--- boot/Makefile.uboot	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/Makefile.uboot	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,5 +40,5 @@
 
 $(POST_OUTPUT): $(BIN_OUTPUT)
-	$(MKUIMAGE) -name "$(IMAGE_NAME)" -laddr $(LADDR) -saddr $(SADDR) -ostype $(UIMAGE_OS) $< $@
+	$(MKUIMAGE) -name "$(IMAGE_NAME)" -laddr 0x30008000 -saddr 0x30008000 $< $@
 
 clean:
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/arch/arm32/Makefile.inc	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -30,14 +30,4 @@
 	BOOT_OUTPUT = image.boot
 	POST_OUTPUT = $(ROOT_PATH)/uImage.bin
-	LADDR = 0x30008000
-	SADDR = 0x30008000
-	POSTBUILD = Makefile.uboot
-endif
-
-ifeq ($(MACHINE), $(filter $(MACHINE),beagleboardxm beaglebone))
-	BOOT_OUTPUT = image.boot
-	POST_OUTPUT = $(ROOT_PATH)/uImage.bin
-	LADDR = 0x80000000
-	SADDR = 0x80000000
 	POSTBUILD = Makefile.uboot
 endif
@@ -49,22 +39,12 @@
 BITS = 32
 ENDIANESS = LE
-EXTRA_CFLAGS = -march=$(subst _,-,$(PROCESSOR_ARCH)) -mno-unaligned-access
+EXTRA_CFLAGS = -march=armv4
 
-ifeq ($(MACHINE), gta02)
 RD_SRVS_ESSENTIAL += \
 	$(USPACE_PATH)/srv/hid/s3c24xx_ts/s3c24xx_ts \
-	$(USPACE_PATH)/srv/hw/char/s3c24xx_uart/s3c24ser
-endif
+	$(USPACE_PATH)/srv/hw/char/s3c24xx_uart/s3c24xx_uart
 
-RD_DRVS += \
-	infrastructure/rootamdm37x \
-	fb/amdm37x_dispc \
-	bus/usb/ehci \
-	bus/usb/ohci \
-	bus/usb/usbflbk \
-	bus/usb/usbhub \
-	bus/usb/usbhid \
-	bus/usb/usbmast \
-	bus/usb/usbmid
+RD_SRVS_NON_ESSENTIAL += \
+	$(USPACE_PATH)/srv/bd/gxe_bd/gxe_bd
 
 SOURCES = \
Index: boot/arch/arm32/_link.ld.in
===================================================================
--- boot/arch/arm32/_link.ld.in	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/arch/arm32/_link.ld.in	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -11,5 +11,4 @@
 	. = BOOT_BASE + 0x8000;
 	.data : {
-		bdata_start = .;
 		*(BOOTPT);      /* bootstrap page table */
 		*(BOOTSTACK);   /* bootstrap stack */
@@ -25,6 +24,5 @@
 [[COMPONENTS]]
 	}
-	bdata_end = .;
-
+	
 	/DISCARD/ : {
 		*(.gnu.*);
Index: boot/arch/arm32/include/arch.h
===================================================================
--- boot/arch/arm32/include/arch.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/arch/arm32/include/arch.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -42,8 +42,4 @@
 #ifdef MACHINE_gta02
 #define BOOT_BASE	0x30008000
-#elif defined MACHINE_beagleboardxm
-#define BOOT_BASE	0x80000000
-#elif defined MACHINE_beaglebone
-#define BOOT_BASE       0x80000000
 #else
 #define BOOT_BASE	0x00000000
@@ -52,18 +48,9 @@
 #define BOOT_OFFSET	(BOOT_BASE + 0xa00000)
 
-#ifdef MACHINE_beagleboardxm
-	#define PA_OFFSET 0
-#elif defined MACHINE_beaglebone
-	#define PA_OFFSET 0
+#ifndef __ASM__
+	#define PA2KA(addr)  (((uintptr_t) (addr)) + 0x80000000)
 #else
-	#define PA_OFFSET 0x80000000
+	#define PA2KA(addr)  ((addr) + 0x80000000)
 #endif
-
-#ifndef __ASM__
-	#define PA2KA(addr)  (((uintptr_t) (addr)) + PA_OFFSET)
-#else
-	#define PA2KA(addr)  ((addr) + PA_OFFSET)
-#endif
-
 
 #endif
Index: boot/arch/arm32/include/main.h
===================================================================
--- boot/arch/arm32/include/main.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/arch/arm32/include/main.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -40,25 +40,4 @@
 /** Address where characters to be printed are expected. */
 
-
-/** BeagleBoard-xM UART register address
- *
- * This is UART3 of AM/DM37x CPU
- */
-#define BBXM_SCONS_THR          0x49020000
-#define BBXM_SCONS_SSR          0x49020044
-
-/* Check this bit before writing (tx fifo full) */
-#define BBXM_THR_FULL           0x00000001
-
-/** Beaglebone UART register addresses
- *
- * This is UART0 of AM335x CPU
- */
-#define BBONE_SCONS_THR         0x44E09000
-#define BBONE_SCONS_SSR         0x44E09044
-
-/** Check this bit before writing (tx fifo full) */
-#define BBONE_TXFIFO_FULL       0x00000001
-
 /** GTA02 serial console UART register addresses.
  *
@@ -72,4 +51,7 @@
 
 
+/** GXemul testarm serial console output register */
+#define TESTARM_SCONS_ADDR	0x10000000
+
 /** IntegratorCP serial console output register */
 #define ICP_SCONS_ADDR		0x16000000
Index: boot/arch/arm32/include/mm.h
===================================================================
--- boot/arch/arm32/include/mm.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/arch/arm32/include/mm.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -47,25 +47,7 @@
 /** Describe "section" page table entry (one-level paging with 1 MB sized pages). */
 #define PTE_DESCRIPTOR_SECTION  0x02
-/** Shift of memory address in section descriptor */
-#define PTE_SECTION_SHIFT  20
 
 /** Page table access rights: user - no access, kernel - read/write. */
 #define PTE_AP_USER_NO_KERNEL_RW  0x01
-
-/** Start of memory mapped I/O area for GTA02 */
-#define GTA02_IOMEM_START  0x48000000
-/** End of memory mapped I/O area for GTA02 */
-#define GTA02_IOMEM_END  0x60000000
-
-/** Start of ram memory on BBxM */
-#define BBXM_RAM_START   0x80000000
-/** Start of ram memory on BBxM */
-#define BBXM_RAM_END   0xc0000000
-
-/** Start of ram memory on AM335x */
-#define AM335x_RAM_START   0x80000000
-/** End of ram memory on AM335x */
-#define AM335x_RAM_END     0xC0000000
-
 
 /* Page table level 0 entry - "section" format is used
@@ -76,14 +58,9 @@
 	unsigned int bufferable : 1;
 	unsigned int cacheable : 1;
-	unsigned int xn : 1;
+	unsigned int impl_specific : 1;
 	unsigned int domain : 4;
 	unsigned int should_be_zero_1 : 1;
-	unsigned int access_permission_0 : 2;
-	unsigned int tex : 3;
-	unsigned int access_permission_1 : 1;
-	unsigned int shareable : 1;
-	unsigned int non_global : 1;
-	unsigned int should_be_zero_2 : 1;
-	unsigned int non_secure : 1;
+	unsigned int access_permission : 2;
+	unsigned int should_be_zero_2 : 8;
 	unsigned int section_base_addr : 12;
 } __attribute__((packed)) pte_level0_section_t;
Index: boot/arch/arm32/src/asm.S
===================================================================
--- boot/arch/arm32/src/asm.S	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/arch/arm32/src/asm.S	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -60,40 +60,3 @@
 	# before passing control to the copied code.
 	#
-
-	#
-	# r0 is kernel entry point
-	# r1 is pointer to the bootinfo structure
-
-#define CP15_C1_IC		12
-#define CP15_C1_BP		11
-#define CP15_C1_DC		2
-	# Disable I-cache and D-cache before the kernel is started.
-	mrc	p15, 0, r4, c1, c0, 0
-	bic	r4, r4, #(1 << CP15_C1_DC)
-	bic	r4, r4, #(1 << CP15_C1_IC)
-	bic	r4, r4, #(1 << CP15_C1_BP)
-	mcr	p15, 0, r4, c1, c0, 0
-
-	
-	#Wait for the operations to complete
-#ifdef PROCESSOR_ARCH_armv7_a
-	dsb
-#else
-	#cp15 dsb, r4 is ignored (should be zero)
-	mcr p15, 0, r4, c7, c10, 4
-#endif
-	
-	# Clean ICache and BPredictors, r4 ignored (SBZ)
-	mcr p15, 0, r4, c7, c5, 0
-	nop
-
-	#Wait for the operations to complete
-#ifdef PROCESSOR_ARCH_armv7_a
-	isb
-	nop
-#else
-	# cp15 isb
-	mcr p15, 0, r4, c7, c5, 4
-	nop
-#endif
 	mov pc, r0
Index: boot/arch/arm32/src/main.c
===================================================================
--- boot/arch/arm32/src/main.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/arch/arm32/src/main.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -50,48 +50,11 @@
 #define TOP2ADDR(top)  (((void *) PA2KA(BOOT_OFFSET)) + (top))
 
-extern void *bdata_start;
-extern void *bdata_end;
-
-
-static inline void invalidate_icache(void)
-{
-	/* ICIALLU Invalidate entire ICache */
-	asm volatile ("mov r0, #0\n" "mcr p15, 0, r0, c7, c5, 0\n" ::: "r0" );
-}
-
-static inline void invalidate_dcache(void *address, size_t size)
-{
-	const uintptr_t addr = (uintptr_t)address;
-	/* DCIMVAC - invalidate by address to the point of coherence */
-	for (uintptr_t a = addr; a < addr + size; a += 4) {
-		asm volatile ("mcr p15, 0, %[a], c7, c6, 1\n" :: [a]"r"(a) : );
-	}
-}
-
-static inline void clean_dcache_poc(void *address, size_t size)
-{
-	const uintptr_t addr = (uintptr_t)address;
-	/* DCCMVAC - clean by address to the point of coherence */
-	for (uintptr_t a = addr; a < addr + size; a += 4) {
-		asm volatile ("mcr p15, 0, %[a], c7, c10, 1\n" :: [a]"r"(a) : );
-	}
-}
-
 static bootinfo_t bootinfo;
 
 void bootstrap(void)
 {
-	/* Make sure  we run in memory code when caches are enabled,
-	 * make sure we read memory data too. This part is ARMv7 specific as
-	 * ARMv7 no longer invalidates caches on restart.
-	 * See chapter B2.2.2 of ARM Architecture Reference Manual p. B2-1263*/
-	invalidate_icache();
-	invalidate_dcache(&bdata_start, &bdata_end - &bdata_start);
-
-	/* Enable MMU and caches */
 	mmu_start();
 	version_print();
 	
-	printf("Boot data: %p -> %p\n", &bdata_start, &bdata_end);
 	printf("\nMemory statistics\n");
 	printf(" %p|%p: bootstrap stack\n", &boot_stack, &boot_stack);
@@ -101,10 +64,9 @@
 	    (void *) PA2KA(BOOT_OFFSET), (void *) BOOT_OFFSET);
 	
-	for (size_t i = 0; i < COMPONENTS; i++) {
+	size_t i;
+	for (i = 0; i < COMPONENTS; i++)
 		printf(" %p|%p: %s image (%u/%u bytes)\n", components[i].start,
 		    components[i].start, components[i].name, components[i].inflated,
 		    components[i].size);
-		invalidate_dcache(components[i].start, components[i].size);
-	}
 	
 	void *dest[COMPONENTS];
@@ -112,5 +74,5 @@
 	size_t cnt = 0;
 	bootinfo.cnt = 0;
-	for (size_t i = 0; i < min(COMPONENTS, TASKMAP_MAX_RECORDS); i++) {
+	for (i = 0; i < min(COMPONENTS, TASKMAP_MAX_RECORDS); i++) {
 		top = ALIGN_UP(top, PAGE_SIZE);
 		
@@ -132,5 +94,5 @@
 	printf("\nInflating components ... ");
 	
-	for (size_t i = cnt; i > 0; i--) {
+	for (i = cnt; i > 0; i--) {
 		void *tail = components[i - 1].start + components[i - 1].size;
 		if (tail >= dest[i - 1]) {
@@ -144,14 +106,14 @@
 		int err = inflate(components[i - 1].start, components[i - 1].size,
 		    dest[i - 1], components[i - 1].inflated);
+		
 		if (err != EOK) {
 			printf("\n%s: Inflating error %d\n", components[i - 1].name, err);
 			halt();
 		}
-		clean_dcache_poc(dest[i - 1], components[i - 1].inflated);
 	}
 	
 	printf(".\n");
 	
-	printf("Booting the kernel...\n");
+	printf("Booting the kernel... \n");
 	jump_to_kernel((void *) PA2KA(BOOT_OFFSET), &bootinfo);
 }
Index: boot/arch/arm32/src/mm.c
===================================================================
--- boot/arch/arm32/src/mm.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/arch/arm32/src/mm.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -38,45 +38,4 @@
 #include <arch/mm.h>
 
-/** Disable the MMU */
-static void disable_paging(void)
-{
-	asm volatile (
-		"mrc p15, 0, r0, c1, c0, 0\n"
-		"bic r0, r0, #1\n"
-		"mcr p15, 0, r0, c1, c0, 0\n"
-		::: "r0"
-	);
-}
-
-/** Check if caching can be enabled for a given memory section.
- *
- * Memory areas used for I/O are excluded from caching.
- * At the moment caching is enabled only on GTA02.
- *
- * @param section	The section number.
- *
- * @return	1 if the given section can be mapped as cacheable, 0 otherwise.
-*/
-static inline int section_cacheable(pfn_t section)
-{
-#ifdef MACHINE_gta02
-	unsigned long address = section << PTE_SECTION_SHIFT;
-
-	if (address >= GTA02_IOMEM_START && address < GTA02_IOMEM_END)
-		return 0;
-	else
-		return 1;
-#elif defined MACHINE_beagleboardxm
-	const unsigned long address = section << PTE_SECTION_SHIFT;
-	if (address >= BBXM_RAM_START && address < BBXM_RAM_END)
-		return 1;
-#elif defined MACHINE_beaglebone
-	const unsigned long address = section << PTE_SECTION_SHIFT;
-	if (address >= AM335x_RAM_START && address < AM335x_RAM_END)
-		return 1;
-#endif
-	return 0;
-}
-
 /** Initialize "section" page table entry.
  *
@@ -95,16 +54,11 @@
 {
 	pte->descriptor_type = PTE_DESCRIPTOR_SECTION;
-	pte->bufferable = 1;
-	pte->cacheable = section_cacheable(frame);
-	pte->xn = 0;
+	pte->bufferable = 0;
+	pte->cacheable = 0;
+	pte->impl_specific = 0;
 	pte->domain = 0;
 	pte->should_be_zero_1 = 0;
-	pte->access_permission_0 = PTE_AP_USER_NO_KERNEL_RW;
-	pte->tex = 0;
-	pte->access_permission_1 = 0;
-	pte->shareable = 0;
-	pte->non_global = 0;
+	pte->access_permission = PTE_AP_USER_NO_KERNEL_RW;
 	pte->should_be_zero_2 = 0;
-	pte->non_secure = 0;
 	pte->section_base_addr = frame;
 }
@@ -113,9 +67,17 @@
 static void init_boot_pt(void)
 {
-	const pfn_t split_page = PTL0_ENTRIES;
+	pfn_t split_page = 0x800;
+	
 	/* Create 1:1 virtual-physical mapping (in lower 2 GB). */
 	pfn_t page;
 	for (page = 0; page < split_page; page++)
 		init_ptl0_section(&boot_pt[page], page);
+	
+	/*
+	 * Create 1:1 virtual-physical mapping in kernel space
+	 * (upper 2 GB), physical addresses start from 0.
+	 */
+	for (page = split_page; page < PTL0_ENTRIES; page++)
+		init_ptl0_section(&boot_pt[page], page - split_page);
 	
 	asm volatile (
@@ -133,23 +95,14 @@
 		/* Behave as a client of domains */
 		"ldr r0, =0x55555555\n"
-		"mcr p15, 0, r0, c3, c0, 0\n"
-
+		"mcr p15, 0, r0, c3, c0, 0\n" 
+		
 		/* Current settings */
 		"mrc p15, 0, r0, c1, c0, 0\n"
 		
-		/* Enable ICache, DCache, BPredictors and MMU,
-		 * we disable caches before jumping to kernel
-		 * so this is safe for all archs.
-		 */
-		"ldr r1, =0x00001805\n"
+		/* Mask to enable paging */
+		"ldr r1, =0x00000001\n"
+		"orr r0, r0, r1\n"
 		
-		"orr r0, r0, r1\n"
-
-		/* Invalidate the TLB content before turning on the MMU.
-		 * ARMv7-A Reference manual, B3.10.3
-		 */
-		"mcr p15, 0, r0, c8, c7, 0\n"
-		
-		/* Store settings, enable the MMU */
+		/* Store settings */
 		"mcr p15, 0, r0, c1, c0, 0\n"
 		::: "r0", "r1"
@@ -159,5 +112,4 @@
 /** Start the MMU - initialize page table and enable paging. */
 void mmu_start() {
-	disable_paging();
 	init_boot_pt();
 	enable_paging();
Index: boot/arch/arm32/src/putchar.c
===================================================================
--- boot/arch/arm32/src/putchar.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/arch/arm32/src/putchar.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -41,48 +41,4 @@
 #include <str.h>
 
-#ifdef MACHINE_beaglebone
-
-/** Send a byte to the am335x serial console.
- *
- * @param byte		Byte to send.
- */
-static void scons_sendb_bbone(uint8_t byte)
-{
-	volatile uint32_t *thr =
-		(volatile uint32_t *) BBONE_SCONS_THR;
-	volatile uint32_t *ssr =
-		(volatile uint32_t *) BBONE_SCONS_SSR;
-
-	/* Wait until transmitter is empty */
-	while (*ssr & BBONE_TXFIFO_FULL);
-
-	/* Transmit byte */
-	*thr = (uint32_t) byte;
-}
-
-#endif
-
-#ifdef MACHINE_beagleboardxm
-
-/** Send a byte to the amdm37x serial console.
- *
- * @param byte		Byte to send.
- */
-static void scons_sendb_bbxm(uint8_t byte)
-{
-	volatile uint32_t *thr =
-	    (volatile uint32_t *)BBXM_SCONS_THR;
-	volatile uint32_t *ssr =
-	    (volatile uint32_t *)BBXM_SCONS_SSR;
-
-	/* Wait until transmitter is empty. */
-	while ((*ssr & BBXM_THR_FULL) == 1) ;
-
-	/* Transmit byte. */
-	*thr = (uint32_t) byte;
-}
-
-#endif
-
 #ifdef MACHINE_gta02
 
@@ -109,4 +65,17 @@
 #endif
 
+#ifdef MACHINE_testarm
+
+/** Send a byte to the GXemul testarm serial console.
+ *
+ * @param byte		Byte to send.
+ */
+static void scons_sendb_testarm(uint8_t byte)
+{
+	*((volatile uint8_t *) TESTARM_SCONS_ADDR) = byte;
+}
+
+#endif
+
 #ifdef MACHINE_integratorcp
 
@@ -128,12 +97,9 @@
 static void scons_sendb(uint8_t byte)
 {
-#ifdef MACHINE_beaglebone
-	scons_sendb_bbone(byte);
-#endif
-#ifdef MACHINE_beagleboardxm
-	scons_sendb_bbxm(byte);
-#endif
 #ifdef MACHINE_gta02
 	scons_sendb_gta02(byte);
+#endif
+#ifdef MACHINE_testarm
+	scons_sendb_testarm(byte);
 #endif
 #ifdef MACHINE_integratorcp
Index: boot/arch/ia64/src/main.c
===================================================================
--- boot/arch/ia64/src/main.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ boot/arch/ia64/src/main.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -48,5 +48,5 @@
 
 #define DEFAULT_MEMORY_BASE		0x4000000ULL
-#define DEFAULT_MEMORY_SIZE		(256 * 1024 * 1024)
+#define DEFAULT_MEMORY_SIZE		0x4000000ULL
 #define DEFAULT_LEGACY_IO_BASE		0x00000FFFFC000000ULL
 #define DEFAULT_LEGACY_IO_SIZE		0x4000000ULL
Index: contrib/conf/arm32-gx.sh
===================================================================
--- contrib/conf/arm32-gx.sh	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ contrib/conf/arm32-gx.sh	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,3 @@
+#!/bin/sh
+
+gxemul $@ -E testarm -X image.boot
Index: contrib/conf/arm32-qe.sh
===================================================================
--- contrib/conf/arm32-qe.sh	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ contrib/conf/arm32-qe.sh	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -1,3 +1,3 @@
 #!/bin/sh
 
-qemu-system-arm $@ -M integratorcp --kernel image.boot -serial stdio
+qemu-system-arm $@ -M integratorcp --kernel image.boot
Index: contrib/conf/ski.conf
===================================================================
--- contrib/conf/ski.conf	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ contrib/conf/ski.conf	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -1,1 +1,1 @@
-load image.boot
+load HelenOS/image.boot
Index: kernel/arch/amd64/Makefile.inc
===================================================================
--- kernel/arch/amd64/Makefile.inc	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/amd64/Makefile.inc	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -33,5 +33,24 @@
 
 FPU_NO_CFLAGS = -mno-sse -mno-sse2
-CMN1 = -m64 -mcmodel=large -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer
+
+#
+# FIXME:
+#
+# The -fno-optimize-sibling-calls should be removed as soon as a bug
+# in GCC concerning the "large" memory model and tail call optimization
+# is fixed.
+#
+# When GCC generates a code for tail call, instead of generating ..
+#
+#   jmp *fnc
+#
+# it generates an assembly code with an illegal immediate prefix:
+#
+#   jmp *$fnc
+#
+# See http://gcc.gnu.org/bugzilla/show_bug.cgi?id=48385 for reference.
+#
+
+CMN1 = -m64 -mcmodel=large -mno-red-zone -fno-unwind-tables -fno-omit-frame-pointer -fno-optimize-sibling-calls
 GCC_CFLAGS += $(CMN1)
 ICC_CFLAGS += $(CMN1)
@@ -76,5 +95,6 @@
 	arch/$(KARCH)/src/proc/thread.c \
 	arch/$(KARCH)/src/userspace.c \
-	arch/$(KARCH)/src/syscall.c
+	arch/$(KARCH)/src/syscall.c \
+	arch/$(KARCH)/src/debugger.c
 
 ifeq ($(CONFIG_SMP),y)
Index: kernel/arch/amd64/include/arch/debugger.h
===================================================================
--- kernel/arch/amd64/include/arch/debugger.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
+++ kernel/arch/amd64/include/arch/debugger.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -0,0 +1,57 @@
+/*
+ * Copyright (c) 2006 Ondrej Palkovsky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup amd64debug
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_amd64_DEBUGGER_H_
+#define KERN_amd64_DEBUGGER_H_
+
+#include <typedefs.h>
+
+#define BKPOINTS_MAX  4
+
+/* Flags that are passed to breakpoint_add function */
+#define BKPOINT_INSTR       0x1U
+#define BKPOINT_WRITE       0x2U
+#define BKPOINT_READ_WRITE  0x4U
+
+#define BKPOINT_CHECK_ZERO  0x8U
+
+
+extern void debugger_init(void);
+extern int breakpoint_add(const void *, const unsigned int, int);
+extern void breakpoint_del(int);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/amd64/include/arch/istate.h
===================================================================
--- kernel/arch/amd64/include/arch/istate.h	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/amd64/include/arch/istate.h	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -66,10 +66,8 @@
 } istate_t;
 
-#define RPL_USER	3
-
 /** Return true if exception happened while in userspace */
 NO_TRACE static inline int istate_from_uspace(istate_t *istate)
 {
-	return (istate->cs & RPL_USER) == RPL_USER;
+	return !(istate->rip & UINT64_C(0x8000000000000000));
 }
 
Index: kernel/arch/amd64/src/amd64.c
===================================================================
--- kernel/arch/amd64/src/amd64.c	(revision 850235d404a93a3e011befe27ef139ef8e288759)
+++ kernel/arch/amd64/src/amd64.c	(revision ea906c296a71e3f2edea0bfac602ee88cf04f607)
@@ -43,4 +43,5 @@
 #include <arch/bios/bios.h>
 #include <arch/boot/boot.h>
+#include <arch/debugger.h>
 #include <arch/drivers/i8254.h>
 #include <arch/drivers/i8259.h>
@@ -160,4 +161,6 @@
 #endif
 		
+		/* Enable debugger */
+		debugger_init();
 		/* Merge all memory zones to 1 big zone */
 		zone_merge_all();
